;====================================================================
if 0
    include \masm32\include\masm32rt.inc
else
    include \masm32\MasmBasic\MasmBasic.inc
endif
    .686
    include \masm32\macros\timers.asm
;====================================================================
    .data
    align 16
        str1 db "my other brother darryl",0
        str2 db 4 dup("my other brother darryl"),0
        str3 db 8 dup("my other brother darryl"),0
    align 16
    if 1
	    sLow db "ths is  tst with ", 0
	    sUpp db "THS IS  TST WITH ", 0
    else
	    sLow db "this is a test", 0
	    sUpp db "THIS IS A TEST", 0
    endif
    .code
;====================================================================
start:
;====================================================================
	push 1
	call ShowCpu	; print brand string and SSE level
	
LC_ALL equ 0
invoke crt_setlocale, LC_ALL, chr$("English")

    invoke Sleep, 500
  MbStrCmp	PROTO: DWORD, :DWORD, :DWORD

    FOR string,<str1,str2,str3>

        print str$(SIZEOF string)," bytes",13,10

        counter_begin 10000, HIGH_PRIORITY_CLASS
	invoke MbStrCmp, offset string, offset string, 1
        counter_end
        print str$(eax)," cycles, MasmBasic",13,10

        counter_begin 10000, HIGH_PRIORITY_CLASS
            invoke szCmpi, ADDR string, ADDR string, SIZEOF string
        counter_end
        print str$(eax)," cycles, szCmpi",13,10

        counter_begin 10000, HIGH_PRIORITY_CLASS
            invoke Cmpi, ADDR string, ADDR string
        counter_end
        print str$(eax)," cycles, Cmpi",13,10

        counter_begin 10000, HIGH_PRIORITY_CLASS
            invoke crt__stricmp, ADDR string, ADDR string
        counter_end
        print str$(eax)," cycles, crt__stricmp",13,10,13,10

    ENDM

print "Correctness:", 13, 10
	.if StringsDiffer(offset sLow, offset sUpp, 1)
		print "non-equal"
	.else
		print "equal"
	.endif
	print " for MasmBasic", 13, 10
;	int 3
	invoke szCmpi, ADDR sLow, ADDR sUpp, SIZEOF sLow
	.if eax
		print "non-equal"
	.else
		print "equal"
	.endif
	print " for szCmpi", 13, 10
	invoke Cmpi, ADDR sLow, ADDR sUpp
	.if eax
		print "non-equal"
	.else
		print "equal"
	.endif
	print " for Cmpi", 13, 10
	invoke crt__stricmp, ADDR sLow, ADDR sUpp, SIZEOF sLow
	.if eax
		print "non-equal"
	.else
		print "equal"
	.endif
	print " for crt__stricmp", 13, 10

    inkey chr$(13, 10, "Press any key to exit...")
    exit

;====================================================================
; select the two lines and press Control X to cut
; code for printing brand string and SSE level
	push 1
	call ShowCpu	; print brand string and SSE level
ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp


end start
OPT_Tmp2Asm	1
